-- 有礼问答
Lua_QuestionGiftWindow = class("Lua_QuestionGiftWindow", Lua_Window);
function Lua_QuestionGiftWindow:ctor()
	self:superCall("ctor");

	self.isFullPaving = true;
	self.windowName = "Lua_QuestionGiftWindow";
	self.skinName = "QuestionGiftWindow_skin";
    self.showBackBtn = true;
    self.isFullSizeWin = true;
end

function Lua_QuestionGiftWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.backBtn:setLocation(60, 80, 0);
	self:createMoney();
	self.rewardList = Lua_ItemIconList.new(self.uitweenObj_2);
	self.rewardList.canClick = true;
	self.rewardList:setLocation(0, -45);
	self.rewardList:setLayout(190, 0, 10);

	self.redPointIcon = Lua_RedPointIcon.new(self.uitweenObj_2, Lua_RedPointList.Question);
	self.redPointIcon:setLocation(88, -284);
	self.redPointIcon:createRedPointEff();


	Lua_ProxyManager.getProxy("Lua_QuestionProxy"):sQuestion()
	self.starBtn:addClickFuntion(self, self.onStarBtnClick);

	self:addLuaEvent("UPDATE_QUESTION_INFO", self, self.unpdateQuestionGift);
end

function Lua_QuestionGiftWindow:createMoney()
	local list = {Lua_ResourcesDefine.DIAMOND, Lua_ResourcesDefine.GOLD};
	local num = list == nil and 0 or #list;
	if num == 0 then
		if self.topBg ~= nil then
			self.topBg:setEnable(false);
		end
	else
		if self.topBg == nil then
			self.topBg = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_widget_036", 0, 0, 720, 52);
			self.topBg.pivot = Lua_WindowUtil.getPivot(1);
			self.topBg.anchor = Lua_WindowUtil.getAnchor(1);
		end
		self.topBg:setEnable(true);
	end

	if self.moneyList == nil then
		self.moneyList = Array();
	end
	local len = self.moneyList:getSize();
	local maxLen = num > len and num or len;
	local item;
	for i = 1, maxLen do
		item = self.moneyList[i];
		if i > num then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_MoneyItem.new(self.content);
				self.moneyList:add(item);
			else
				item:setEnable(true);
			end
			item:setRectAnchor(1);
			item:setLocation(249 - (i - 1) * 190, -26, 0);
			item:setCanClick(true);
			item:setMoney(list[i]);
		end
	end
end

function Lua_QuestionGiftWindow:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_QuestionGiftWindow:unpdateQuestionGift()
	self.cfgData = DataCenter.questionUtil:getQuestionVersionCfgData(DataCenter.questionData.version_id);
	if self.cfgData ~= nil then
		self.rewardList:setArrayData(self.cfgData.reward);
	end
	if DataCenter.roleData.level < self.cfgData.open_lvl then
		self.limit_txt.text = LanUtil.formateStr(650015,tostring(DataCenter.roleData.level),tostring(self.cfgData.open_lvl));
		self.limit_txt:setEnable(true);
	end
	self:startTimer();
end

function Lua_QuestionGiftWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:updateQuestionTime();
		self:addTimer("Lua_QuestionGiftWindow", 1, self, self.updateQuestionTime);
	end
end

function Lua_QuestionGiftWindow:updateQuestionTime()
	local time = DataCenter.questionData.residueTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
	end
	self.timeTxt.text = LanUtil.formateStr(650000, Lua_TimeTransform.transSeconds16(time, true, true, true));
end

function Lua_QuestionGiftWindow:endTimer()
	if self.bTimer then
		self.bTimer = false;
		self:removeTimer(self, self.updateQuestionTime);
	end
end

function Lua_QuestionGiftWindow:onStarBtnClick(go)
	if DataCenter.roleData.level < self.cfgData.open_lvl then
		local str = LanUtil.formateStr(650016,tostring(self.cfgData.open_lvl));
		OperateAlert.show(str);
		return 
	end
	Lua_WindowUtil.openWin("Lua_QuestionWindow", Lua_WinParam.ACTION_OPEN);
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.Question, false);
	self:hide();
end

function Lua_QuestionGiftWindow:dispose()
	if self.giftItemt ~= nil then
		self.giftItemt:dispose();
		self.giftItemt = nil;
	end
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	if self.moneyList ~= nil then
		self.moneyList:dispose();
		self.moneyList:clear();
		self.moneyList = nil;
	end
	self.topBg = nil;
	self.cfgData = nil;
	self:endTimer();

	self:superCall("dispose");
end