--矩阵选择题
Lua_QuestionMatrixSelectPanel = class("Lua_QuestionMatrixSelectPanel", Lua_DisplayObject);
function Lua_QuestionMatrixSelectPanel:ctor(p)
	self:superCall("ctor", p,"QuestionMatrixSelectPanel_skin");
end

function Lua_QuestionMatrixSelectPanel:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("ON_MATRIX_SELECT_BOX_CLICK", self, self.onSelectBoxClick);
end

function Lua_QuestionMatrixSelectPanel:setData(id, bool)
	self.data = DataCenter.questionUtil:getQuestionCfgDataById(id);
	self.title_txt.text = self.data.matrix_title;

	local list = self.data.content;
    if self.selectInfo == nil then
        self.selectInfo = Array();
    end
    local len = self.selectInfo:getSize();
    for i = 1, len do
        self.selectInfo[i]:setEnable(false);
    end

    local item;
    for i = 1, #list do
        if self.selectInfo[i] ~= nil then
            item = self.selectInfo[i];
        else
            item = Lua_QuestionMatrixSelectItem.new(self.content);
            self.selectInfo:add(item);
        end
        item:setData(list[i], i, id);
		item:setLocation(-31 + ( i - 1) * 79, 185, 0);
        item:setEnable(true);
    end

    local arr = DataCenter.questionUtil:getSelectQuestionArr(id);--选择项
    if arr ~= nil then
	    self:onSelectBoxClick({index = arr[i], cfgId = id});
	end
	self.line:setEnable(not bool);
end

function Lua_QuestionMatrixSelectPanel:onSelectBoxClick(param)
	local cfgId = param.cfgId;
	if cfgId ~= self.data.id then
		return
	end

	local index = param.index;
	local limit_max = self.data.limit_max;
	if limit_max <= 1 then--单选
		if self.select_index ~= index then
			DataCenter.questionUtil:removeClientQuestion(self.data.id, self.select_index);--移除选项
		end
		DataCenter.questionUtil:addClientQuestion(self.data.id, index);--添加选项

		self:updateSetSelectItem(index, 1);
		self.select_index = index;
	else--多选
		if self.selectDic == nil then
			self.selectDic = {};
		end
		if self.selectDic[index] == nil then--选中
			self.select_num = self.select_num + 1;
			if self.select_num > limit_max then
				OperateAlert.showLangValue(650002);
				return
			end
			self.selectDic[index] = 1;
			DataCenter.questionUtil:addClientQuestion(self.data.id, index);--添加选项
		else
			self.select_num = self.select_num - 1;
			self.selectDic[index] = nil;
			DataCenter.questionUtil:removeClientQuestion(self.data.id, index);--移除选项
		end
		self:updateSetSelectItem(nil, 2);
	end
end

--更新选中项
function Lua_QuestionMatrixSelectPanel:updateSetSelectItem(index, select_type)
	if self.selectInfo ~= nil then
		local item_index;
		for i=1, self.selectInfo:getSize() do
			item_index = self.selectInfo[i].index;
			if select_type == 1 then --单选
				self.selectInfo[i]:setSelectedState(item_index == index);
			elseif select_type == 2 then --多选
				self.selectInfo[i]:setSelectedState(self.selectDic[item_index] == 1);
			end
		end
	end
end

function Lua_QuestionMatrixSelectPanel.Get:offectY()
	return -89;
end

function Lua_QuestionMatrixSelectPanel:dispose()
	self.data = nil;
	self.selectDic = nil;--选择计数
	if self.selectInfo ~= nil then
		self.selectInfo:dispose();
		self.selectInfo:clear();
		self.selectInfo = nil;
	end
	self:superCall("dispose");
end


















--选择题
Lua_QuestionMatrixSelectItem = class("Lua_QuestionMatrixSelectItem", Lua_DisplayObject);
function Lua_QuestionMatrixSelectItem:ctor(p)
	self:superCall("ctor", p, "QuestionMatrixSelectItem_skin");
end

function Lua_QuestionMatrixSelectItem:buildShowItem()
	self:superCall("buildShowItem");
	self.selectIcon:setEnable(false);
	self.selectBg.clickScale = false;
	self.selectBg:addClickFuntion(self, self.onSelectClick);
end

function Lua_QuestionMatrixSelectItem:dispose()
	self:superCall("dispose");
end

function Lua_QuestionMatrixSelectItem:setData(id, index, cfgId)
	self.cfgId = cfgId;
	self.index = index;
	local cfgData = DataCenter.questionUtil:getQuestionOptionCfgData(id);
	if cfgData == nil then
		return
	end
	self.des_txt.text = cfgData.des;
end

function Lua_QuestionMatrixSelectItem:setSelectedState(bool)
	self.selectIcon:setEnable(bool);
end

function Lua_QuestionMatrixSelectItem:onSelectClick()
	Lua_MsgUtil.callFunc("ON_MATRIX_SELECT_BOX_CLICK", {cfgId = self.cfgId, index = self.index});
end