--量表题
Lua_QuestionSectionPanel = class("Lua_QuestionSectionPanel", Lua_DisplayObject);
function Lua_QuestionSectionPanel:ctor(p)
	self:superCall("ctor", p,"QuestionSectionPanel_skin");
end

function Lua_QuestionSectionPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.progressBar = Lua_QuestionSectionBar.new(self.content,"question_atlas", "xui_wjdc_progress_1_b", "xui_wjdc_progress_1_f", 490, 40);
	self.progressBar:setLocation(0,166,0);
	self.progressBar:setCallBack(self, self.onProgressBarClikc, self.onProgressBarEnd)
end

function Lua_QuestionSectionPanel:setData(id)
	self.data = DataCenter.questionUtil:getQuestionCfgDataById(id);
	local list = self.data.content;
	if list ~= nil then
		local cfgDataL = DataCenter.questionUtil:getQuestionOptionCfgData(list[1]);
		local cfgDataR = DataCenter.questionUtil:getQuestionOptionCfgData(list[2]);
		self.desL_txt.text = cfgDataL.des;
		self.desR_txt.text = cfgDataR.des;
		self.desL_txt:setEnable(true);
		self.desR_txt:setEnable(true);
	end

	local limit_max = self.data.limit_max;
	
	
    if self.txtInfo == nil then
        self.txtInfo = Array();
    end
    local len = self.txtInfo:getSize();
    for i = 1, len do
        self.txtInfo[i]:setEnable(false);
    end

    self.space = 492/limit_max;
    local item;
    local cfgData;
    for i = 1, limit_max do
        if self.txtInfo[i] ~= nil then
            item = self.txtInfo[i];
        else
            item = Lua_QuestionSectionItem.new(self.content);
            self.txtInfo:add(item);
        end
        item:setData(i)
		item:setLocation(-221 + ( i - 1) * self.space, 165, 0);
        item:setEnable(true);
    end

    local arr = DataCenter.questionUtil:getSelectQuestionArr(id);--选择项
    if arr ~= nil and arr:getSize() > 0 then
    	for i=1,arr:getSize() do
    		self:onBarClick(arr[i]);
    		self:updateBarTxt(arr[i]);
    		self.progressBar:setValue(arr[i], 1, limit_max);
    	end
    else
    	self:onBarClick(1);
    	self:updateBarTxt(1);
    	self.progressBar:setValue(1, 1, limit_max);
	end
end

function Lua_QuestionSectionPanel:onBarClick(index)
	if self.tagIndex ~= index and self.tagIndex ~= nil then
		DataCenter.questionUtil:removeClientQuestion(self.data.id, self.tagIndex);--添加选项
	end
	self.tagIndex = index;
	DataCenter.questionUtil:addClientQuestion(self.data.id, index);--添加选项
end


function Lua_QuestionSectionPanel:updateBarTxt(val)
	local posx = self.space*val;
	self.num_txt.text = val;
	LuaUtil.setObjPos(self.posObj,posx, 0, 0);

	for i=1,self.txtInfo:getSize() do
		self.txtInfo[i]:setText(val);
	end
end

function Lua_QuestionSectionPanel:onProgressBarClikc(val)
	-- LogManager.showLog("点击进度条 = ="..val)
	if val <=0 then
		val = 1;
	end
	self:updateBarTxt(val);
end

function Lua_QuestionSectionPanel:onProgressBarEnd(val)
	-- LogManager.showLog("点击进度条结束 = ="..val)
	if val <= 0 then
		val = 1;
	end
	self:onBarClick(val);
end

function Lua_QuestionSectionPanel.Get:offectY()
	return 50;
end


function Lua_QuestionSectionPanel:dispose()
	if self.txtInfo ~= nil then
		self.txtInfo:dispose();
		self.txtInfo:clear();
		self.txtInfo = nil;
	end
	if self.progressBar ~= nil then
		self.progressBar:dispose();
		self.progressBar = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end











Lua_QuestionSectionItem = class("Lua_QuestionSectionItem", Lua_DisplayObject);
function Lua_QuestionSectionItem:ctor(p)
	self:superCall("ctor", p, "QuestionSectionItem_skin");
end

function Lua_QuestionSectionItem:buildShowItem()
	self:superCall("buildShowItem");

end

function Lua_QuestionSectionItem:setData(id)
	self.id = id;
end

function Lua_QuestionSectionItem:setText(num)
	local color = "9a8a74";
	if self.id <= num then
		color = "c98a17";
	end
	self.num_txt.text = Lua_ColorDefine.getColorStr(color, self.id);
end

function Lua_QuestionSectionItem:dispose()

	self:superCall("dispose");
end

















--进度条
Lua_QuestionSectionBar = class("Lua_QuestionSectionBar", Lua_DisplayObject);
function Lua_QuestionSectionBar:ctor(p, barAtlas, bgSprite, barSprite, barWidth, barHeight, offsetWidth, offsetHeight)
	self.barAtlas = barAtlas;
	self.bgSprite = bgSprite;
	self.barSprite = barSprite;
	self.barWidth = barWidth == nil and 150 or barWidth;
	self.barHeight = barHeight == nil and 30 or barHeight;
	self.offsetWidth = offsetWidth == nil and 0 or offsetWidth;
	self.offsetHeight = offsetHeight == nil and 0 or offsetHeight;
	self:superCall("ctor", p);
end

function Lua_QuestionSectionBar:buildShowItem()
	self:superCall("buildShowItem");
	self.bar_bg = UICreate.createUIAtlasImage(self.content, self.barAtlas, self.bgSprite, 0, 0, self.barWidth, self.barHeight);
	self.bar_bg.typeValue = 1;
	self.bar_bg.clickScale = false;
	self.bar_bg:addMousDownFuntion(self, self.onMousDownClick);
	self.bar_bg:addMouseUpFuntion(self, self.onMousUpClick);

	self.bar = UICreate.createUIAtlasImage(self.content, self.barAtlas, self.barSprite, -self.barWidth/2, 0, 0, self.barHeight);
	self.bar.pivotValue = 3;
	self.bar.typeValue = 1;

	self:setValue(0, 0, 100);
end

function Lua_QuestionSectionBar:dispose()
	if self.bTimer ~= nil and self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onLongPress);
	end

	self.owner = nil;
	self.callBack = nil;
	self.endCallBack = nil;
	self:superCall("dispose");
end

function Lua_QuestionSectionBar:setCallBack(owner, callBack, endCallBack)
	self.owner = owner;
	self.callBack = callBack;
	self.endCallBack = endCallBack;
end

function Lua_QuestionSectionBar:setValue(curNum, minNum, maxNum)
	self.curNum = curNum;
	self.minNum = minNum;
	self.maxNum = maxNum;
	self.averageVal = self.barWidth/maxNum;
	self:setBarWidth(curNum);
end

function Lua_QuestionSectionBar:onMousDownClick(go)
	self:startTimer();
end

function Lua_QuestionSectionBar:onMousUpClick(go)
	self:cleanTimer();
end

function Lua_QuestionSectionBar:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self.clickTime = getTime();
		self:addTimer("Lua_QuestionSectionBar", 0.01, self, self.onLongPress, nil, -1);
	end
end

function Lua_QuestionSectionBar:cleanTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onLongPress);
	end

	if self.owner ~= nil and self.endCallBack ~= nil then
		self.endCallBack(self.owner, self.curNum);
	end
end

function Lua_QuestionSectionBar:onLongPress()
	if getTime() - self.clickTime > 0.3 then
		self.bLongPress = true;
		self:onLessPlusNum();
	else
		self.bLongPress = false;
		self:updateNum();
	end
end

function Lua_QuestionSectionBar:onLessPlusNum()
	self:updateNum();
end

function Lua_QuestionSectionBar:setBarWidth(curNum)
	self.bar:SetDimensions(self.averageVal*curNum, self.barHeight);
end

function Lua_QuestionSectionBar:updateNum()
	local winPos = LuaUtil.getTouchPosInverseObj(self.content);
	local movetoPosx = winPos.x + self.barWidth/2;
	self.curNum = Mathf.Ceil((movetoPosx/self.barWidth)*10);
	if self.curNum > self.maxNum then
		self.curNum = self.maxNum;
	elseif self.curNum <= self.minNum then
		self.curNum = self.minNum;
	end

    self.bar:SetDimensions(self.curNum*self.averageVal, self.barHeight);

	if self.owner ~= nil and self.callBack ~= nil then
		self.callBack(self.owner, self.curNum);
	end
end
