--选择题
Lua_QuestionSelectPanel = class("Lua_QuestionSelectPanel", Lua_DisplayObject);
function Lua_QuestionSelectPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_QuestionSelectPanel:buildShowItem()
	self:superCall("buildShowItem");
	self._offectY = 0;
	self.dragContainer = Lua_DragContainer.new(self.content, 470, 615, Lua_AxisDefine.Vertical);
	self.dragContainer:setLocation(0, -55, 0);

	self:addLuaEvent("ON_SELECT_BTN_CLICK", self, self.onSelectBoxClick);
	self:addLuaEvent("ON_SELECT_INPUT_CLICK", self, self.onSelectInputClick);
end

function Lua_QuestionSelectPanel:setData(id)
	self.select_num = 0;
	self.data = DataCenter.questionUtil:getQuestionCfgDataById(id);
    local list = self.data.content;
    
	if list ~= nil then
		for i = 1, #list do
			self.dragContainer:addSubContainer(Lua_QuestionSelectItem, {id = list[i], index = i, cfgid = id}, false);
		end
		self.dragContainer:updateChildPos();
	end

	self.dragContainer.canDrag = self.dragContainer.subRectH > self.dragContainer._rectHeight;
    self._offectY = self.dragContainer._rectHeight;

    local arr = DataCenter.questionUtil:getSelectQuestionArr(id);--选择项
    if arr ~= nil then
	    for i=1,arr:getSize() do
	    	local words = DataCenter.questionUtil:getWordsQuestion(id, arr[i]);
	    	self:onSelectBoxClick({index = arr[i], words = words});
	    end
	end
end

function Lua_QuestionSelectPanel:onSelectBoxClick(data)
	local index = data.index;
	local words = data.words;
	
	local limit_max = self.data.limit_max;
	if limit_max <= 1 then--单选
		if self.select_index ~= index then
			DataCenter.questionUtil:removeClientQuestion(self.data.id, self.select_index);--移除选项
		end
		DataCenter.questionUtil:addClientQuestion(self.data.id, index, words);--添加选项

		self.select_index = index;
	else--多选
		if self.selectDic == nil then
			self.selectDic = {};
		end

		if self.selectDic[index] == nil then--选中
			if self.select_num >= limit_max then
				OperateAlert.show(LanUtil.formateStr(650002, tostring(limit_max)));
			else
				self.selectDic[index] = 1;
				self.select_num = self.select_num + 1;
				-- print(self.data.id, index, words)
				DataCenter.questionUtil:addClientQuestion(self.data.id, index, words);--添加选项
			end
		else
			self.select_num = self.select_num - 1;
			self.selectDic[index] = nil;
			DataCenter.questionUtil:removeClientQuestion(self.data.id, index);--移除选项
		end
	end
end

function Lua_QuestionSelectPanel:onSelectInputClick(param)

	local index = param.index;
	local words = param.words;
	local limit_max = self.data.limit_max;
	if limit_max <= 1 then--单选
		if self.select_index ~= index then
			self:onSelectBoxClick(param);
		else
			DataCenter.questionUtil:addClientQuestion(self.data.id, index, words);--添加选项
		end
	else
		if self.selectDic == nil or self.selectDic[index] == nil then--选中
			self:onSelectBoxClick(param);
		else
			DataCenter.questionUtil:addClientQuestion(self.data.id, index, words);--添加选项
		end
	end
end

function Lua_QuestionSelectPanel.Get:offectY()
	return self._offectY;
end


function Lua_QuestionSelectPanel:dispose()
	self.data = nil;
	self.selectDic = nil;--选择计数
	if self.selectInfo ~= nil then
		self.selectInfo:dispose();
		self.selectInfo:clear();
		self.selectInfo = nil;
	end
	self:superCall("dispose");
end














--选择题
Lua_QuestionSelectItem = class("Lua_QuestionSelectItem", Lua_DragContainerItem);
function Lua_QuestionSelectItem:ctor(p)
	self:superCall("ctor", p, "QuestionSelectItem_skin");
end

function Lua_QuestionSelectItem:buildShowItem()
	self:superCall("buildShowItem");
	self.selectIcon:setEnable(false);
	self.selectBg.clickScale = false;
	self.selectBg:addClickFuntion(self, self.onSelectClick);
	self.des_txt:addClickFuntion(self, self.onSelectClick);
	self:addLuaEvent("UPDATE_QUESTION_SELECT", self, self.updateSelect);
end

function Lua_QuestionSelectItem:setData(data)
	self.data = data;
	local optionCfgData = DataCenter.questionUtil:getQuestionOptionCfgData(self.data.id);
	if optionCfgData == nil then
		return
	end
	self.limit_max = DataCenter.questionUtil:getQuestionCfgDataById(self.data.cfgid).limit_max;
	 
	self.fontSize = optionCfgData.fontSize == nil and 20 or optionCfgData.fontSize;
	self.limit_num = optionCfgData.limit_num;
	if self.limit_num == nil then
		self.des_txt.horizontalOverflowValue = 1;
		self.des_txt:SetDimensions(42,31);
		self.des_txt.text = optionCfgData.des;
		self.des_txt.fontSize = self.fontSize;
		self.des_txt:resetSize();

		if tonumber(self.des_txt.width) >= 405 then
			self.des_txt:SetDimensions(405,31);
			self.des_txt.horizontalOverflowValue = 0;
			self.des_txt:resetSize();
		end

		self.des_txt:setEnable(true);
		self:createInput(false);
	else--填空选项
		self.des_txt:setEnable(false);
		self:createInput(true);
	end
	self.selectBg:setEnable(true);
	self:updateSelect();
end

function Lua_QuestionSelectItem:updateSelect()
	local arr = DataCenter.questionUtil:getSelectQuestionArr(self.data.cfgid);
	self.selectIcon:setEnable(false);
	self.bSelectSelf = false;--是否选择了自己
	local index_len = 0;
	if arr ~= nil then
		index_len = arr:getSize();
		for i=1, index_len do
			if self.limit_max <= 1 then --单选
				self.selectIcon:setEnable(arr[i] == self.data.index);
			else
				if arr[i] == self.data.index then
					self.selectIcon:setEnable(true);
					self.bSelectSelf = true;
					break;
				end
			end
		end
	end

	self.bSelectMax = index_len >= self.limit_max;--选择达到上限
	if self.inputText ~= nil then
		local str = DataCenter.questionUtil:getWordsQuestion(self.data.cfgid, self.data.index);
		if str ~= nil then
			self.inputText.text = str;
			self.inputText:setEnable(true);
		else
			self.firstInput = false;
		end
	end
end

function Lua_QuestionSelectItem:createInput(bool)
	if self.inputText == nil and bool then
		self.firstInput = true;
		self.inputText = UICreate.createInput(self.content, "", 0, 0, 340, 40, self.fontSize);
	    self.inputText.alignmentValue = 3;
	    -- self.inputText.contentTypeValue = 2;
	    self.inputText.colorStr = Lua_ColorDefine.transColor("867E7B");
		
		self.inputText.strLenLimit = self.limit_num;
		self.inputText:onChange(self, self.onChangeShow);
		-- self.inputText:addClickFuntion(self, self.onInputClick);

	    self.line = UICreate.createUIAtlasImage(self.content, "question_atlas", "xui_wjdc_line_3", 0, -18, 340, 2);
	    self.line:setEnable(true);
	else
		if self.inputText ~= nil then
			self.inputText:dispose();
			self.inputText = nil;
		end
		if self.line ~= nil then
			self.line:setEnable(bool);
		end
	end
end

function Lua_QuestionSelectItem:onChangeShow()
	if self.firstInput then
		self.firstInput = false;
		return
	end

	local show1 = utf8len(self.inputText.text);
	local words = self.inputText.text;
	if self.inputText.text == "" then
		words = nil;
	end
	if not self.bSelectMax or self.bSelectSelf then
		Lua_MsgUtil.callFunc("ON_SELECT_INPUT_CLICK",{index = self.data.index, words = words});
		Lua_MsgUtil.callFunc("UPDATE_QUESTION_SELECT");
	end
	if show1 == self.limit_num then
		OperateAlert.showLangValue(650017);
		return
	end
end

function Lua_QuestionSelectItem:onSelectClick()
	local words = nil
	if self.limit_num ~= nil and not self.bSelectSelf then
		self.inputText:ActivateInputField();
		words = self.inputText.text;
		if self.inputText.text == "" then
			words = nil;
		end
	end

	Lua_MsgUtil.callFunc("ON_SELECT_BTN_CLICK",{index = self.data.index, words = words});
	Lua_MsgUtil.callFunc("UPDATE_QUESTION_SELECT");
end

function Lua_QuestionSelectItem:getWidth()
    return 470;
end

function Lua_QuestionSelectItem:getHeight()
	local off_h = 14 + self.selectBg.height;
	if self.des_txt.height > self.selectBg.height then
		off_h = self.des_txt.height + 14;
	end
    return off_h;
end

function Lua_QuestionSelectItem:dispose()
	self.inputText = nil;
	self.line = nil;
	self.data = nil;
	self:superCall("dispose");
end