--题号展示
Lua_QuestionShowWindow = class("Lua_QuestionShowWindow", Lua_Window);
function Lua_QuestionShowWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_QuestionShowWindow";
	self.skinName = "QuestionShowWindow_skin";
	self.isClickClose = true;
	self.showBlackMask = true;
	self.blackAlpha = 0.1;
end

function Lua_QuestionShowWindow:buildShowItem()
	self:superCall("buildShowItem");
    self.dragList = Lua_DragList.new(self.content,290, 60, Lua_AxisDefine.Horizontal);
    self.dragList:setListCell(Lua_QuestionShowCell, 50, 60, 1);
    -- self.dragList:setCellSpacing(5, 0);
    self.dragList:setLocation(-160, -372, 0);
end

function Lua_QuestionShowWindow:showWin(param)
	self:superCall("showWin",param);
    local all_num = DataCenter.questionUtil.all_num;
    local arr = Array();
    for i=1, all_num do
    	arr:add(i);
    end
    self.dragList.customParam = param;
    self.dragList:setArrayData(arr);
    self.dragList:moveToIndex(param);
end

function Lua_QuestionShowWindow:dispose()

    self:superCall("dispose");
end



















Lua_QuestionShowCell = class("Lua_QuestionShowCell", Lua_ListCell);
function Lua_QuestionShowCell:ctor(p)
    self:superCall("ctor", p, "QuestionShowItem_skin");
end

function Lua_QuestionShowCell:buildShowItem()
    self:superCall("buildShowItem");

end

function Lua_QuestionShowCell:setData(page)
	self.page = page;
	local bool = page == self.cur_page;
	self.bLock = DataCenter.questionUtil:bSelectCurPage(page) or bool;
	self.lock:setEnable(not self.bLock);
	self.mash:setEnable(not self.bLock);
	self.num_txt.text = page;
	self.num_txt:setEnable(not bool);
	if bool then
		if self.num == nil then
			self.num = Lua_NumberImage.new(self.content);
			self.num.numOffsetX = -5;
			self.num.numAtlas = "number";
			self.num.preStr = "xui_wjdc_number_";
		end
		self.num:setEnable(true);
		self.num.num = self.cur_page;
	else
		if self.num ~= nil then
			self.num:setEnable(false);
		end
	end
end

function Lua_QuestionShowCell:setCustomParam(customParam)
    self.cur_page = customParam;--当前答题
end

function Lua_QuestionShowCell:onPressClick()
	if self.bLock then
    	if self.page == self.cur_page then
    		OperateAlert.showLangValue(650014);
	    	return
    	end
    	local bool = DataCenter.questionUtil:bSelectQuestion(self.cur_page);
    	if bool == false then
    		OperateAlert.showLangValue(650009);
    	else
    		Lua_MsgUtil.callFunc("ON_SELECT_QUESTION_PAGE", self.page);
    	end
    else
    	OperateAlert.showLangValue(650010);
    end
end

function Lua_QuestionShowCell:dispose()
    self.data = nil;
    self:superCall("dispose");
end