--问卷系统
checkRequire("Lua_QuestionPanel");--答题面板
Lua_QuestionWindow = class("Lua_QuestionWindow", Lua_Window);
function Lua_QuestionWindow:ctor()
	self:superCall("ctor");

    self.isFullPaving = true;
	self.windowName = "Lua_QuestionWindow";
	self.skinName = "QuestionWindow_skin";
    self.showBackBtn = true;
end

function Lua_QuestionWindow:buildShowItem()
	self:superCall("buildShowItem");
    self.backBtn:setLocation(-300, -645, 0);
    self.name_txt.text = DataCenter.roleData.name;
    
	self.page = DataCenter.questionUtil.curPage;--当前题
	self.questionDic, self.all_num = DataCenter.questionUtil:getQuestionDic();

	self:updateQuestion(self.page);
    self.nextBtn:addClickFuntion(self, self.onNextBtnClick);
    self.selectBtn:addClickFuntion(self, self.onSelectBtnClick);

    self:addLuaEvent("ON_SELECT_QUESTION_PAGE", self, self.updateQuestion);
end

function Lua_QuestionWindow:updateQuestion(page)

	if self.questionDic == nil or self.questionDic[page] == nil then
		return
	end
    -- print(self.questionDic[page]," page == ",page)
    self.page = page;
    if self.panel == nil then
        self.panel = Lua_QuestionPanel.new(self.content);
    end
    self.panel:setData(self.questionDic[page]);
    local str = page;
    if page < self.all_num then
        str = Lua_ColorDefine.getColorStr("ed4c30",page);
    end

    self.num_txt.text = LanUtil.formateStr(650006,tostring(str),tostring(self.all_num));


    local bool = DataCenter.questionUtil:bSelectCurPage(1);
    if bool then
        self.selectBtn:setEnable(true);
        self.nextBtn:setLocation(155,-449.5,0);
    else
        self.selectBtn:setEnable(false);
        self.nextBtn:setLocation(0,-449.5,0);
    end
    
    if page == self.all_num then
        self.nextBtn.label = LanUtil.getValue(650008);
    else
        self.nextBtn.label = LanUtil.getValue(650007);
    end

    Lua_WindowUtil.openWin("Lua_QuestionShowWindow", Lua_WinParam.ACTION_CLOSE);
end 

function Lua_QuestionWindow:onSelectBtnClick()
    Lua_WindowUtil.openWin("Lua_QuestionShowWindow", Lua_WinParam.ACTION_OPEN, self.page);
end

function Lua_QuestionWindow:onNextBtnClick()
    local bool = DataCenter.questionUtil:bSelectQuestion(self.page, true);
    if bool then
        if self.page == self.all_num then
            Lua_ProxyManager.getProxy("Lua_QuestionProxy"):sSubmitQuestionCondition();
            OperateAlert.showLangValue(650011);
            self:hide();
            return;
        else
            Lua_ProxyManager.getProxy("Lua_QuestionProxy"):sSaveQuestionCondition(self.page);
            local bActive = false
            while bActive == false do
                self.page = self.page + 1;
                local arr = self.questionDic[self.page];
                for i=1,arr:getSize() do
                    bActive = DataCenter.questionUtil:getTriggerState(arr[i]);
                    if bActive then
                        break;
                    end
                end
            end
            -- print("self.page = ",self.page);
            if bActive then
                self:updateQuestion(self.page);
            end
        end
    end
end

function Lua_QuestionWindow:dispose()
    if self.panel == nil then
        self.panel:dispose();
        self.panel = nil;
    end
	self.wordsDic = nil;--答题内容
    self.indexDic = nil;-- 答题选择
    self.triggerDic = nil;--前置触发列表
    DataCenter.questionUtil:dispose();
	self:superCall("dispose");
end